#local Bigaangle = -92;

#declare ArchPat =
intersection {
   union {
	lathe {
	5,
	<15.99,-4.1>,<19,-4.1>,<19,4.1>,<15.99,4.1>,<15.99,-4.1>
		}
	torus {19,0.2 translate <0,-4.1,0> texture { LightStone }}
	torus {15.99,0.2 translate <0,-4.1,0> texture { LightStone }}
#while (Bigaangle < 92)
	cylinder {<15.99,-4.1,0>,<19,-4.1,0>, 0.1 rotate <0,-Bigaangle,0> texture { LightStone }}
	#local Bigaangle = Bigaangle + 4;
#end
	  }
	box {<0,-4.4,-19.2>,<19.2,4.4,19.2>}
	texture { vDarkStone }
	}

/////////

#declare CutIndianArch =
intersection {
difference {
	union {
		cylinder {<0,0,-4>,<0,0,4>,4 translate <4,-4,0>}
		box {<-4,-4,-4>,<4,4,4>}
			}
	cylinder {<0,0,-4.01>,<0,0,4.01>,4 translate <4,4,0>}
		}
	box {<0.000001,-4,-4.1>,<8.1,4.1,4.1>}
	translate <0,4,0>
	scale <2,2,1.01>
	}

#declare IndianPat =
difference {
	object { CutIndianArch scale <1.2,1.2,1.05> }
	object { CutIndianArch scale <0.99,1,1.1> translate <0,-0.05,0> }
	rotate <0,90,0>
	texture { vDarkStone }
	}

////

#local mcCount = -18;
#local yC = 19;

#declare IndianArch =
	prism {
	-4,4,
	123,
	<20,0>,<20,21>,<0,21>,<0,17>,<2,12>,<15,6>,<18,0>,<20,0>,

#while(mcCount < 0)
	<-1-mcCount,-1+yC>,<1-mcCount,-1+yC>,<1-mcCount,1+yC>,<-mcCount-1,1+yC>,<-mcCount-1,-1+yC>,
	#local mcCount = mcCount + 3;
#end

#local mcCount = -16.5;
#local yC = 16;

#while(mcCount < -1.5)
	<-1-mcCount,-1+yC>,<1-mcCount,-1+yC>,<1-mcCount,1+yC>,<-mcCount-1,1+yC>,<-mcCount-1,-1+yC>,
	<-1-mcCount+1.5,-1+yC-3>,<1-mcCount+1.5,-1+yC-3>,<1-mcCount+1.5,1+yC-3>,<-mcCount-1+1.5,1+yC-3>,<-mcCount-1+1.5,-1+yC-3>,
	#local mcCount = mcCount + 3;
#end
	<-0.6+2,-0.6+16>,<0.6+2,-0.6+16>,<0.6+2,0.6+16>,<-0.6+2,0.6+16>,<-0.6+2,-0.6+16>,
	<-0.5+3.5,-0.5+13.5>,<0.5+3.5,-0.5+13.5>,<0.5+3.5,0.6+13.5>,<-0.5+3.5,0.5+13.5>,<-0.5+3.5,-0.5+13.5>,
	<-1+17,-1+10>,<1+17,-1+10>,<1+17,1+10>,<-1+17,1+10>,<-1+17,-1+10>,

	<-0.7+18,-0.7+7>,<0.7+18,-0.7+7>,<0.7+18,0.7+7>,<-0.7+18,0.7+7>,<-0.7+18,-0.7+7>,
	<-0.7+13.5,-0.7+10.3>,<0.7+13.5,-0.7+10.3>,<0.7+13.5,0.7+10.3>,<-0.7+13.5,0.7+10.3>,<-0.7+13.5,-0.7+10.3>,
	<-0.5+10.5,-0.5+10.5>,<0.5+10.5,-0.5+10.5>,<0.5+10.5,0.5+10.5>,<-0.5+10.5,0.5+10.5>,<-0.5+10.5,-0.5+10.5>,

	<-0.3+7.5,-0.3+10.7>,<0.3+7.5,-0.3+10.7>,<0.3+7.5,0.3+10.7>,<-0.3+7.5,0.3+10.7>,<-0.3+7.5,-0.3+10.7>
	rotate <-90,90,0>
	}

///

#declare prBaseA =
prism {
	conic_sweep
	0.8,1,
	5,
	<-4.5,-4.5>,<4.5,-4.5>,<4.5,4.5>,<-4.5,4.5>,<-4.5,-4.5>
	translate <0,-0.8,0>
	scale <1,10,1>
	translate <0,-4,20>
	texture { Bricky2 }
		}

#declare ABigArch =
difference {
	box {<-4,0,-20>,<4,21,20>}
	cylinder {<-4.1,0,0>,<4.1,0,0>,16 }
	}

#declare CastleBigArch =
union {
	box {<-4.5,1,4.5>,<4.5,3,-4.5> translate <0,-3,20> texture { Bricky2 }}
	object { IndianArch }
	object { IndianArch rotate <0,180,0> }
	object { IndianPat }
	object { IndianPat rotate <0,180,0> }
	object { prBaseA }
	}

#declare CastleBigArch2 =
union {
	object { ABigArch }
	object { ArchPat rotate <0,0,90> }
	}

#declare CastleBigArch3 =
union {
	object { IndianArch }
	object { IndianPat texture { DarkStone scale 1/6.25 } }
	object { IndianArch rotate <0,180,0> }
	object { IndianPat texture { DarkStone scale 1/6.25 } rotate <0,180,0> }
	box {<-4.5,1,4.5>,<4.5,3,-4.5> translate <0,-3,20> }
	object { prBaseA }
	scale 6.25
	}

/////////

#local railCoord = 12;

#declare TopRailersCyls =
union {																	// rails for tower
#while ( railCoord < 220 )
	cylinder {<4,68,railCoord>,<4,72.5,railCoord>,0.2}
	sphere {<4,68,railCoord>,0.3 texture { LightStone}}
	#local railCoord = railCoord + 5.3333333333;
#end
	texture { Rails }
	}

#declare TopRailersOne =
union {
	object { SineWave(0,0,2.5,2,220,0.15) rotate <0,-90,0> translate <4,70.25,10>}
	object { SineWave(0,120,2.5,2,220,0.15) rotate <0,-90,0> translate <4,70.25,10>}
	object { SineWave(0,240,2.5,2,220,0.15) rotate <0,-90,0> translate <4,70.25,10>}

	object { SineWave(0,60,2.5,2,220,0.15) rotate <0,-90,0> translate <4,70.25,10>}
	object { SineWave(0,180,2.5,2,220,0.15) rotate <0,-90,0> translate <4,70.25,10>}
	object { SineWave(0,300,2.5,2,220,0.15) rotate <0,-90,0> translate <4,70.25,10>}
	object { TopRailersCyls }
		}

#declare TopRailers =
union {
	object { TopRailersOne }
	object { TopRailersOne translate <-8,0,0> }
	}